package com.sa.ibiz.demo.demo.rest;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.domain.OrgUnitCat;
import com.sa.ibiz.demo.demo.service.OrgUnitCatService;
import com.sa.ibiz.demo.demo.service.dto.OrgUnitCatSearchFilter;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import java.math.BigInteger;
import java.util.List;

@RestController
@RequestMapping("/demo/orgunitcat")
public class OrgUnitCatResource
{
	@Autowired
	private OrgUnitCatService service;


	@PostMapping(value = "/remove")
	public ResponseEntity<OrgUnitCat> remove(@Validated @RequestBody OrgUnitCat data){
		boolean bRt=service.remove(data);
		if(!bRt)
			throw new BadRequestAlertException("组织单元类别[remove]操作发生错误","OrgUnitCat",data.getOrgunitcatid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/checkKey")
	public ResponseEntity<OrgUnitCat> checkKey(@Validated @RequestBody OrgUnitCat data){
		boolean bRt=service.checkKey(data);
		if(!bRt)
			throw new BadRequestAlertException("组织单元类别[checkKey]操作发生错误","OrgUnitCat",data.getOrgunitcatid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/update")
	public ResponseEntity<OrgUnitCat> update(@Validated @RequestBody OrgUnitCat data){
		boolean bRt=service.update(data);
		if(!bRt)
			throw new BadRequestAlertException("组织单元类别[update]操作发生错误","OrgUnitCat",data.getOrgunitcatid().toString());
		return ResponseEntity.ok().body(data);
	}
	@GetMapping(value = "/{id}")
	public ResponseEntity<OrgUnitCat> get(@Validated @PathVariable String id){
		OrgUnitCat data=new OrgUnitCat();
		data.setOrgunitcatid(id);;
		data=service.get(data);
		if(data==null)
			throw new BadRequestAlertException("组织单元类别[get]操作发生错误","OrgUnitCat",id.toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/create")
	public ResponseEntity<OrgUnitCat> create(@Validated @RequestBody OrgUnitCat data){
		boolean bRt=service.create(data);
		if(!bRt)
			throw new BadRequestAlertException("组织单元类别[create]操作发生错误","OrgUnitCat",data.getOrgunitcatid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/getDraft")
	public ResponseEntity<OrgUnitCat> getDraft(@Validated @RequestBody OrgUnitCat data){
		boolean bRt=service.getDraft(data);
		if(!bRt)
			throw new BadRequestAlertException("组织单元类别[getDraft]操作发生错误","OrgUnitCat","");
		return ResponseEntity.ok().body(data);
	}
    @PostMapping(value="/searchdefault")
	public ResponseEntity<Page<OrgUnitCat>> searchDefaultPage(@Validated @RequestBody OrgUnitCatSearchFilter filter){
		Page<OrgUnitCat> searchResult = service.searchDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}

	@PostMapping(value="/listdefault")
	public ResponseEntity<List<OrgUnitCat>> listDefault(@Validated @RequestBody OrgUnitCatSearchFilter filter){
		List<OrgUnitCat> searchResult = service.listDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}
}
